<template>
  <InputField
    v-model="data.value"
    autocomplete="new-password"
    type="password"
    title="Password"
    @blur="toogleErrorsShown(true)"
    @input="tryResetErrors"
  >
    <ErrorMark
      v-if="errorsShown && !!errors"
      v-model="errors"
    />
  </InputField>
</template>

<script lang="ts" setup>
import type { Rules } from 'async-validator';
import { useAsyncValidator } from '@vueuse/integrations/useAsyncValidator';
import { InputField } from '~shared/ui';
import ErrorMark from './ErrorMark.vue';
import { useAuthStore } from '~/stores/auth';

const props = defineProps<{
  modelValue: string;
}>();
const emit = defineEmits<{
  (e: 'update:modelValue', elem: string): void;
  (e: 'pass', elem: boolean): void;
}>();
const data = reactive({ value: props.modelValue });
const [errorsShown, toogleErrorsShown] = useToggle();
const rules: Rules = {
  value: {
    type: 'string',
    required: true,
    min: 8,
    max: 32,
  },
};
const { pass, errors: validationErrors } = useAsyncValidator(data, rules);
const store = useAuthStore();
const errors = computed(() =>
  store.errors.has ? store.errors.password : validationErrors.value,
);

watch(data, () => emit('update:modelValue', data.value));
watch(pass, () => emit('pass', pass.value));

const tryResetErrors = () => {
  store.tryResetErrors();
  toogleErrorsShown(false);
};
</script>
